## libhugetlbfs 2.11

=== Makefile ===
PREFIX ?= /usr/local
EXEDIR ?= /bin

LIBOBJS = hugeutils.o version.o init.o morecore.o debug.o alloc.o shm.o kernel-features.o
LIBPUOBJS = init_privutils.o debug.o hugeutils.o kernel-features.o
INSTALL_OBJ_LIBS = libhugetlbfs.so libhugetlbfs.a libhugetlbfs_privutils.so
BIN_OBJ_DIR=obj
PM_OBJ_DIR=TLBC
INSTALL_BIN = hugectl hugeedit hugeadm pagesize
INSTALL_SCRIPT = cpupcstat oprofile_map_events.pl oprofile_start.sh
INSTALL_HELPER = huge_page_setup_helper.py
INSTALL_PERLMOD = DataCollect.pm OpCollect.pm PerfCollect.pm Report.pm
INSTALL_HEADERS = hugetlbfs.h
INSTALL_MAN1 = pagesize.1
INSTALL_MAN3 = get_huge_pages.3 get_hugepage_region.3 \
		gethugepagesizes.3 getpagesizes.3
INSTALL_MAN7 = libhugetlbfs.7
INSTALL_MAN8 = hugectl.8 hugeedit.8 hugeadm.8 cpupcstat.8
LDSCRIPT_TYPES = B BDT
LDSCRIPT_DIST_ELF = elf32ppclinux elf64ppc elf_i386 elf_x86_64
INSTALL_OBJSCRIPT = ld.hugetlbfs
VERSION=version.h
SOURCE = $(shell find . -maxdepth 1 ! -name version.h -a -name '*.[h]')
SOURCE += *.c *.lds Makefile
NODEPTARGETS=<version.h> <clean>

INSTALL = install

LDFLAGS += -Wl,-z,noexecstack -ldl
CFLAGS ?= -O2 -g
CFLAGS += -Wall -fPIC
CPPFLAGS += -D__LIBHUGETLBFS__

ARCH = $(shell uname -m | sed -e s/i.86/i386/)

ifeq ($(ARCH),ppc64)
CC64 = gcc -m64
ELF64 = elf64ppc
TMPLIB64 = lib64
TMPLIB32 = lib
ifneq ($(BUILDTYPE),NATIVEONLY)
CC32 = gcc -m32
ELF32 = elf32ppclinux
endif
else
ifeq ($(ARCH),ppc)
CC32 = gcc -m32
ELF32 = elf32ppclinux
TMPLIB32 = lib
else
ifeq ($(ARCH),i386)
CC32 = gcc
ELF32 = elf_i386
TMPLIB32 = lib
else
ifeq ($(ARCH),x86_64)
CC64 = gcc -m64
ELF64 = elf_x86_64
TMPLIB64 = lib64
TMPLIB32 = lib
ifneq ($(BUILDTYPE),NATIVEONLY)
CC32 = gcc -m32
ELF32 = elf_i386
endif
else
ifeq ($(ARCH),ia64)
CC64 = gcc
TMPLIB64 = lib64
CFLAGS += -DNO_ELFLINK
else
ifeq ($(ARCH),sparc64)
CC64 = gcc -m64
TMPLIB64 = lib64
CFLAGS += -DNO_ELFLINK
else
ifeq ($(ARCH),s390x)
CC64 = gcc -m64
CC32 = gcc -m31
TMPLIB64 = lib64
TMPLIB32 = lib
CFLAGS += -DNO_ELFLINK
else
$(error "Unrecognized architecture ($(ARCH))")
endif
endif
endif
endif
endif
endif
endif

ifdef CC32
OBJDIRS += obj32
endif
ifdef CC64
OBJDIRS +=  obj64
endif

ifdef CC64
CCBIN = $(CC64)
else
CCBIN = $(CC32)
endif

ifdef ELF32
LIBOBJS32 = obj32/elflink.o obj32/sys-$(ELF32).o
endif
ifdef ELF64
LIBOBJS64 = obj64/elflink.o obj64/sys-$(ELF64).o
endif
ifeq ($(ELF32),elf32ppclinux)
LIBOBJS32 += obj32/$(ELF32).o
endif
ifeq ($(ELF64),elf64ppc)
LIBOBJS64 += obj64/$(ELF64).o
endif
LIBOBJS32 += $(LIBOBJS:%=obj32/%)
LIBOBJS64 += $(LIBOBJS:%=obj64/%)

ifeq ($(LIB32),)
LIB32 = $(TMPLIB32)
endif

ifdef TMPLIB64
ifeq ($(LIB64),)
LIB64 = $(TMPLIB64)
endif
endif

# If TMPLIB64 is set, then sure we are not resolving LIB32 and LIB64 to the
# same place
ifdef TMPLIB64

REALLIB32 = $(realpath $(PREFIX)/$(LIB32))
REALLIB64 = $(realpath $(PREFIX)/$(LIB64))
ifneq ($(realpath $(PREFIX)),)
ifeq ($(REALLIB32),$(REALLIB64))
$(error LIB32 ($(PREFIX)/$(LIB32) to $(REALLIB32)) and LIB64 ($(PREFIX)/$(LIB64) to $(REALLIB64)) are resolving to the same place. Manually specify LIB32 and LIB64. e.g. make PREFIX=$(PREFIX) LIB32=lib32 LIB64=lib64)
endif
endif

endif

HEADERDIR = $(PREFIX)/include
LIBDIR32 = $(PREFIX)/$(LIB32)
LIBDIR64 = $(PREFIX)/$(LIB64)
LDSCRIPTDIR = $(PREFIX)/share/libhugetlbfs/ldscripts
BINDIR = $(PREFIX)/share/libhugetlbfs
EXEDIR = $(PREFIX)/bin
DOCDIR = $(PREFIX)/share/doc/libhugetlbfs
PMDIR = $(PREFIX)/lib/perl5/TLBC
MANDIR1 = $(PREFIX)/share/man/man1
MANDIR3 = $(PREFIX)/share/man/man3
MANDIR7 = $(PREFIX)/share/man/man7
MANDIR8 = $(PREFIX)/share/man/man8

ifdef LIB32
LIBPATHS += -DLIB32='"$(LIB32)"' -DLIBDIR32='"$(LIBDIR32)"'
endif
ifdef LIB64
LIBPATHS += -DLIB64='"$(LIB64)"' -DLIBDIR64='"$(LIBDIR64)"'
endif

EXTRA_DIST = \
	README \
	HOWTO \
	LGPL-2.1

INSTALL_LDSCRIPTS = $(foreach type,$(LDSCRIPT_TYPES),$(LDSCRIPT_DIST_ELF:%=%.x$(type)))

ifdef V
VECHO = :
else
VECHO = echo "	"
ARFLAGS = rc
.SILENT:
endif

DEPFILES = $(LIBOBJS:%.o=%.d)

export ARCH
export OBJDIRS
export CC32
export CC64
export ELF32
export ELF64
export LIBDIR32
export LIBDIR64

all:	libs tests tools

.PHONY:	tests libs

libs:	$(foreach file,$(INSTALL_OBJ_LIBS),$(OBJDIRS:%=%/$(file))) $(BIN_OBJ_DIR)/libhugetlbfs_privutils.a

tests:	libs # Force make to build the library first
tests:	tests/all

tests/%:
	$(MAKE) -C tests $*

tools:  $(foreach file,$(INSTALL_BIN),$(BIN_OBJ_DIR)/$(file))

check:	all
	cd tests; ./run_tests.py

checkv:	all
	cd tests; ./run_tests.py -vV

func:	all
	cd tests; ./run_tests.py -t func

funcv:	all
	cd tests; ./run_tests.py -t func -vV

stress:	all
	cd tests; ./run_tests.py -t stress

stressv: all
	cd tests; ./run_tests.py -t stress -vV

# Don't want to remake objects just 'cos the directory timestamp changes
$(OBJDIRS): %:
	@mkdir -p $@

# <Version handling>
$(VERSION): always
	@$(VECHO) VERSION
	./localversion version $(SOURCE)
always:
# </Version handling>

snapshot: $(VERSION)

.SECONDARY:

obj32/%.o: %.c
	@$(VECHO) CC32 $@
	@mkdir -p obj32
	$(CC32) $(CPPFLAGS) $(CFLAGS) -o $@ -c $<

obj64/%.o: %.c
	@$(VECHO) CC64 $@
	@mkdir -p obj64
	$(CC64) $(CPPFLAGS) $(CFLAGS) -o $@ -c $<

obj32/%.o: %.S
	@$(VECHO) AS32 $@
	@mkdir -p obj32
	$(CC32) $(CPPFLAGS) -o $@ -c $<

obj64/%.o: %.S
	@$(VECHO) AS64 $@
	@mkdir -p obj64
	$(CC64) $(CPPFLAGS) -o $@ -c $<

obj32/libhugetlbfs.a: $(LIBOBJS32)
	@$(VECHO) AR32 $@
	$(AR) $(ARFLAGS) $@ $^

obj64/libhugetlbfs.a: $(LIBOBJS64)
	@$(VECHO) AR64 $@
	$(AR) $(ARFLAGS) $@ $^

obj32/libhugetlbfs.so: $(LIBOBJS32)
	@$(VECHO) LD32 "(shared)" $@
	$(CC32) $(LDFLAGS) -Wl,--version-script=version.lds -Wl,-soname,$(notdir $@) -shared -o $@ $^ $(LDLIBS)

obj64/libhugetlbfs.so: $(LIBOBJS64)
	@$(VECHO) LD64 "(shared)" $@
	$(CC64) $(LDFLAGS) -Wl,--version-script=version.lds -Wl,-soname,$(notdir $@) -shared -o $@ $^ $(LDLIBS)

#obj32/libhugetlbfs_privutils.a: $(LIBPUOBJS:%=obj32/%)
#	@$(VECHO) AR32 $@
#	$(AR) $(ARFLAGS) $@ $^
#
#obj64/libhugetlbfs_privutils.a: $(LIBPUOBJS:%=obj64/%)
#	@$(VECHO) AR64 $@
#	$(AR) $(ARFLAGS) $@ $^

$(BIN_OBJ_DIR)/libhugetlbfs_privutils.a: $(LIBPUOBJS:%=$(BIN_OBJ_DIR)/%)
	@$(VECHO) ARHOST $@
	$(AR) $(ARFLAGS) $@ $^

obj32/libhugetlbfs_privutils.so: $(LIBPUOBJS:%=obj32/%)
	@$(VECHO) LD32 "(shared)" $@
	$(CC32) $(LDFLAGS) -Wl,--version-script=privutils.lds -Wl,-soname,$(notdir $@) -shared -o $@ $^ $(LDLIBS)

obj64/libhugetlbfs_privutils.so: $(LIBPUOBJS:%=obj64/%)
	@$(VECHO) LD64 "(shared)" $@
	$(CC64) $(LDFLAGS) -Wl,--version-script=privutils.lds -Wl,-soname,$(notdir $@) -shared -o $@ $^ $(LDLIBS)

obj32/%.i:	%.c
	@$(VECHO) CPP $@
	$(CC32) $(CPPFLAGS) -E $< > $@

obj64/%.i:	%.c
	@$(VECHO) CPP $@
	$(CC64) $(CPPFLAGS) -E $< > $@

obj32/%.s:	%.c
	@$(VECHO) CC32 -S $@
	$(CC32) $(CPPFLAGS) $(CFLAGS) -o $@ -S $<

obj64/%.s:	%.c
	@$(VECHO) CC64 -S $@
	$(CC64) $(CPPFLAGS) $(CFLAGS) -o $@ -S $<

$(BIN_OBJ_DIR)/%.o: %.c
	@$(VECHO) CCHOST $@
	@mkdir -p $(BIN_OBJ_DIR)
	$(CCBIN) $(CPPFLAGS) $(CFLAGS) $(LIBPATHS) -o $@ -c $<

$(BIN_OBJ_DIR)/hugectl: $(BIN_OBJ_DIR)/hugectl.o
	@$(VECHO) LDHOST $@
	mkdir -p $(BIN_OBJ_DIR)
	$(CCBIN) $(CPPFLAGS) $(CFLAGS) -o $@ $^

$(BIN_OBJ_DIR)/hugeedit: $(BIN_OBJ_DIR)/hugeedit.o
	@$(VECHO) LDHOST $@
	mkdir -p $(BIN_OBJ_DIR)
	$(CCBIN) $(CPPFLAGS) $(CFLAGS) $(LIBPATHS) -o $@ $^

HUGEADM_OBJ=hugeadm.o libhugetlbfs_privutils.a
$(BIN_OBJ_DIR)/hugeadm: $(foreach file,$(HUGEADM_OBJ),$(BIN_OBJ_DIR)/$(file))
	@$(VECHO) LDHOST $@
	mkdir -p $(BIN_OBJ_DIR)
	$(CCBIN) $(CPPFLAGS) $(CFLAGS) $(LIBPATHS) -o $@ $^

PAGESIZE_OBJ=pagesize.o libhugetlbfs_privutils.a
$(BIN_OBJ_DIR)/pagesize: $(foreach file,$(PAGESIZE_OBJ),$(BIN_OBJ_DIR)/$(file))
	@$(VECHO) LDHOST $@
	mkdir -p $(BIN_OBJ_DIR)
	$(CCBIN) $(CPPFLAGS) $(CFLAGS) $(LIBPATHS) -o $@ $^

clean:
	@$(VECHO) CLEAN
	rm -f *~ *.o *.so *.a *.d *.i core a.out $(VERSION)
	rm -rf obj*
	rm -f ldscripts/*~
	rm -f libhugetlbfs-sock
	$(MAKE) -C tests clean

%.d: %.c $(VERSION)
	@$(CC) $(CPPFLAGS) -MM -MT "$(foreach DIR,$(OBJDIRS),$(DIR)/$*.o) $@" $< > $@

# Workaround: Don't build dependencies for certain targets
#    When the include below is executed, make will use the %.d target above to
# generate missing files.  For certain targets (clean, version.h, etc) we don't
# need or want these dependency files, so don't include them in this case.
ifeq (,$(findstring <$(MAKECMDGOALS)>,$(NODEPTARGETS)))
-include $(DEPFILES)
endif

obj32/install:
	@$(VECHO) INSTALL-LIB32 $(LIBDIR32)
	$(INSTALL) -d $(DESTDIR)$(LIBDIR32)
	$(INSTALL) $(INSTALL_OBJ_LIBS:%=obj32/%) $(DESTDIR)$(LIBDIR32)

obj64/install:
	@$(VECHO) INSTALL-LIB64 $(LIBDIR64)
	$(INSTALL) -d $(DESTDIR)$(LIBDIR64)
	$(INSTALL) $(INSTALL_OBJ_LIBS:%=obj64/%) $(DESTDIR)$(LIBDIR64)

objscript.%: %
	@$(VECHO) OBJSCRIPT $*
	sed "s!### SET DEFAULT LDSCRIPT PATH HERE ###!HUGETLB_LDSCRIPT_PATH=$(LDSCRIPTDIR)!" < $< > $@

install-libs: libs $(OBJDIRS:%=%/install) $(INSTALL_OBJSCRIPT:%=objscript.%)
	$(INSTALL) -d $(DESTDIR)$(HEADERDIR)
	$(INSTALL) -d $(DESTDIR)$(LDSCRIPTDIR)
	$(INSTALL) -d $(DESTDIR)$(BINDIR)
	$(INSTALL) -m 644 -t $(DESTDIR)$(HEADERDIR) $(INSTALL_HEADERS)
	$(INSTALL) -m 644 $(INSTALL_LDSCRIPTS:%=ldscripts/%) $(DESTDIR)$(LDSCRIPTDIR)
	for x in $(INSTALL_OBJSCRIPT); do \
		$(INSTALL) -m 755 objscript.$$x $(DESTDIR)$(BINDIR)/$$x; done
	cd $(DESTDIR)$(BINDIR) && ln -sf ld.hugetlbfs ld

install-man:
	@$(VECHO) INSTALL_MAN $(DESTDIR)manX
	$(INSTALL) -d $(DESTDIR)$(MANDIR1)
	$(INSTALL) -d $(DESTDIR)$(MANDIR3)
	$(INSTALL) -d $(DESTDIR)$(MANDIR7)
	$(INSTALL) -d $(DESTDIR)$(MANDIR8)
	for x in $(INSTALL_MAN1); do \
		$(INSTALL) -m 444 man/$$x $(DESTDIR)$(MANDIR1); \
		gzip -f $(DESTDIR)$(MANDIR1)/$$x; \
	done
	for x in $(INSTALL_MAN3); do \
		$(INSTALL) -m 444 man/$$x $(DESTDIR)$(MANDIR3); \
		gzip -f $(DESTDIR)$(MANDIR3)/$$x; \
	done
	rm -f $(DESTDIR)$(MANDIR3)/free_huge_pages.3.gz
	rm -f $(DESTDIR)$(MANDIR3)/free_hugepage_region.3.gz
	ln -s get_huge_pages.3.gz $(DESTDIR)$(MANDIR3)/free_huge_pages.3.gz
	ln -s get_hugepage_region.3.gz $(DESTDIR)$(MANDIR3)/free_hugepage_region.3.gz
	for x in $(INSTALL_MAN7); do \
		$(INSTALL) -m 444 man/$$x $(DESTDIR)$(MANDIR7); \
		gzip -f $(DESTDIR)$(MANDIR7)/$$x; \
	done
	for x in $(INSTALL_MAN8); do \
		$(INSTALL) -m 444 man/$$x $(DESTDIR)$(MANDIR8); \
		gzip -f $(DESTDIR)$(MANDIR8)/$$x; \
	done

install-bin:
	@$(VECHO) INSTALL_BIN $(DESTDIR)$(EXEDIR)
	$(INSTALL) -d $(DESTDIR)$(EXEDIR)
	for x in $(INSTALL_BIN); do \
		$(INSTALL) -m 755 $(BIN_OBJ_DIR)/$$x $(DESTDIR)$(EXEDIR); done

install-stat: install-perlmod
	@$(VECHO) INSTALL_SCRIPT $(DESTDIR)$(EXEDIR)
	$(INSTALL) -d $(DESTDIR)$(EXEDIR)
	for x in $(INSTALL_SCRIPT); do \
		$(INSTALL) -m 755 $$x $(DESTDIR)$(EXEDIR); done

install-perlmod:
	@$(VECHO) INSTALL_PERLMOD $(DESTDIR)$(PMDIR)
	$(INSTALL) -d $(DESTDIR)$(PMDIR)
	for x in $(INSTALL_PERLMOD); do \
		$(INSTALL) -m 644 $(PM_OBJ_DIR)/$$x $(DESTDIR)$(PMDIR); done

install: install-libs install-bin install-man install-stat

install-helper:
	@$(VECHO) INSTALL_HELPER $(DESTDIR)$(EXEDIR)
	$(INSTALL) -d $(DESTDIR)$(EXEDIR)
	for x in $(INSTALL_HELPER); do \
		$(INSTALL) -m 755 $$x $(DESTDIR)$(EXEDIR); done

install-docs:
	$(INSTALL) -d $(DESTDIR)$(DOCDIR)
	for x in $(EXTRA_DIST); do $(INSTALL) -m 755 $$x $(DESTDIR)$(DOCDIR)/$$x; done

install-tests: tests install	# Force make to build tests and install the library first
	${MAKE} -C tests install DESTDIR=$(DESTDIR) OBJDIRS="$(OBJDIRS)" LIB32=$(LIB32) LIB64=$(LIB64)

=== tests/Makefile ===
PREFIX = /usr/local

LIB_TESTS = gethugepagesize test_root find_path unlinked_fd misalign \
	readback truncate shared private fork-cow empty_mounts large_mounts \
	meminfo_nohuge ptrace-write-hugepage icache-hygiene slbpacaflush \
	chunk-overcommit mprotect alloc-instantiate-race mlock \
	truncate_reserve_wraparound truncate_sigbus_versus_oom \
	map_high_truncate_2 truncate_above_4GB direct \
	misaligned_offset brk_near_huge task-size-overrun stack_grow_into_huge \
	counters quota heap-overflow get_huge_pages get_hugepage_region \
	shmoverride_linked gethugepagesizes \
	madvise_reserve fadvise_reserve readahead_reserve \
	shm-perms
LIB_TESTS_64 = straddle_4GB huge_at_4GB_normal_below \
	huge_below_4GB_normal_above
NOLIB_TESTS = malloc malloc_manysmall dummy heapshrink shmoverride_unlinked
LDSCRIPT_TESTS = zero_filesize_segment
HUGELINK_TESTS = linkhuge linkhuge_nofd linkshare
HUGELINK_RW_TESTS = linkhuge_rw
STRESS_TESTS = mmap-gettest mmap-cow shm-gettest shm-getraw shm-fork
WRAPPERS = quota counters madvise_reserve fadvise_reserve \
	readahead_reserve mremap-expand-slice-collision \
	mremap-fixed-normal-near-huge mremap-fixed-huge-near-normal
HELPERS = get_hugetlbfs_path compare_kvers
HELPER_LIBS = libheapshrink.so
BADTOOLCHAIN = bad-toolchain.sh

CFLAGS = -O2 -Wall -g
CPPFLAGS = -I..
LDLIBS = -Wl,--no-as-needed -ldl -lpthread -lhugetlbfs_privutils
LDFLAGS32 = -L../obj32
LDFLAGS64 = -L../obj64
INSTALL = install

TESTS = $(LIB_TESTS) $(NOLIB_TESTS) $(STRESS_TESTS) dummy.ldscript
ifdef ELF32
TESTS += $(LDSCRIPT_TESTS) $(HUGELINK_TESTS) $(HUGELINK_TESTS:%=xB.%) \
	$(HUGELINK_TESTS:%=xBDT.%) $(HUGELINK_RW_TESTS)
else
ifdef ELF64
TESTS += $(LDSCRIPT_TESTS) $(HUGELINK_TESTS) $(HUGELINK_TESTS:%=xB.%) \
	$(HUGELINK_TESTS:%=xBDT.%)
endif
endif

ifneq ($(ARCH),ia64)
TESTS_64 = $(LIB_TESTS_64)
endif

SCRIPTS=../ldscripts
SCRIPTS32 = $(SCRIPTS)/$(ELF32)
SCRIPTS64 = $(SCRIPTS)/$(ELF64)
HUGETLBFS_LD=../ld.hugetlbfs
INST_TESTSDIR32 = $(LIBDIR32)/libhugetlbfs/tests
INST_TESTSDIR64 = $(LIBDIR64)/libhugetlbfs/tests

ifdef V
VECHO = :
else
VECHO = echo "	"
.SILENT:
endif

DEPFILES = $(LIB_TESTS:%=%.d) $(NOLIB_TESTS:%=%.d) $(HUGELINK_TESTS:%=%.d) \
	$(HELPERS:%=%.d) testutils.d

ALLTESTS = $(foreach DIR,$(OBJDIRS),$(TESTS:%=$(DIR)/%))
ALLHELPERS = $(foreach DIR,$(OBJDIRS),$(HELPERS:%=$(DIR)/%))
ALLHELPERLIBS = $(foreach DIR,$(OBJDIRS),$(HELPER_LIBS:%=$(DIR)/%))
ifdef CC64
ALLTESTS += $(TESTS_64:%=obj64/%)
endif

objs_needing_wrappers = \
	$(foreach W,$(WRAPPERS:%.sh=%),$(filter $(1)/$(W),$(ALLTESTS)))
WRAPPERS32 = $(addsuffix .sh,$(call objs_needing_wrappers,obj32))
WRAPPERS64 = $(addsuffix .sh,$(call objs_needing_wrappers,obj64))
ALLWRAPPERS = $(WRAPPERS32) $(WRAPPERS64)

all:	$(ALLTESTS) $(ALLHELPERS) $(ALLHELPERLIBS) $(ALLWRAPPERS)

shmoverride_linked.c: shmoverride_unlinked.c
	ln -s shmoverride_unlinked.c shmoverride_linked.c

obj32/%.o: %.c
	@$(VECHO) CC32 $@
	@mkdir -p obj32
	$(CC32) $(CPPFLAGS) $(CFLAGS) -o $@ -c $<

obj64/%.o: %.c
	@$(VECHO) CC64 $@
	@mkdir -p obj64
	$(CC64) $(CPPFLAGS) $(CFLAGS) -o $@ -c $<

obj32/%-pic.o: %.c
	@$(VECHO) CC32 $@
	@mkdir -p obj32
	$(CC32) $(CPPFLAGS) $(CFLAGS) -fPIC -o $@ -c $<

obj64/%-pic.o: %.c
	@$(VECHO) CC64 $@
	@mkdir -p obj64
	$(CC64) $(CPPFLAGS) $(CFLAGS) -fPIC -o $@ -c $<

obj32/libheapshrink.so: obj32/heapshrink-helper-pic.o
	@$(VECHO) LD32 "(shared)" $@
	@mkdir -p obj32
	$(CC32) -Wl,-soname,$(notdir $@) -shared -o $@ $^

obj64/libheapshrink.so: obj64/heapshrink-helper-pic.o
	@$(VECHO) LD64 "(shared)" $@
	@mkdir -p obj64
	$(CC64) -Wl,-soname,$(notdir $@) -shared -o $@ $^

$(LIB_TESTS:%=obj32/%): %: %.o obj32/testutils.o obj32/libtestutils.o
	@$(VECHO) LD32 "(lib test)" $@
	$(CC32) $(LDFLAGS) $(LDFLAGS32) -o $@ $^ $(LDLIBS) -lhugetlbfs

$(LIB_TESTS:%=obj64/%) $(LIB_TESTS_64:%=obj64/%): %: %.o obj64/testutils.o obj64/libtestutils.o
	@$(VECHO) LD64 "(lib test)" $@
	$(CC64) $(LDFLAGS) $(LDFLAGS64) -o $@ $^ $(LDLIBS) -lhugetlbfs

$(NOLIB_TESTS:%=obj32/%): %: %.o obj32/testutils.o
	@$(VECHO) LD32 "(nolib test)" $@
	$(CC32) $(LDFLAGS) $(LDFLAGS32) -o $@ $^ $(LDLIBS)

$(NOLIB_TESTS:%=obj64/%): %: %.o obj64/testutils.o
	@$(VECHO) LD64 "(nolib test)" $@
	$(CC64) $(LDFLAGS) $(LDFLAGS64) -o $@ $^ $(LDLIBS)

obj32/%.ldscript: obj32/%.o obj32/testutils.o
	@$(VECHO) SCRIPT32 $@
	$(CC32) $(LDFLAGS) $(LDFLAGS32) -Wl,--verbose -o/dev/null $^ $(LDLIBS) > $@

obj64/%.ldscript: obj64/%.o obj64/testutils.o
	@$(VECHO) SCRIPT64 $@
	$(CC64) $(LDFLAGS) $(LDFLAGS64) -Wl,--verbose -o/dev/null $^ $(LDLIBS) > $@

$(LDSCRIPT_TESTS:%=obj32/%): obj32/%: %.ld obj32/%.o obj32/testutils.o
	@$(VECHO) LD32 "(preload test)" $@
	$(CC32) $(LDFLAGS) $(LDFLAGS32) -o $@ -Lobj32 $^ $(LDLIBS) || cp $(BADTOOLCHAIN) $@

$(LDSCRIPT_TESTS:%=obj64/%): obj64/%: %.ld obj64/%.o obj64/testutils.o
	@$(VECHO) LD64 "(preload test)" $@
	$(CC64) $(LDFLAGS) $(LDFLAGS64) -o $@ -Lobj64 $^ $(LDLIBS) || cp $(BADTOOLCHAIN) $@

$(HUGELINK_TESTS:%=obj32/%): %: %.o obj32/testutils.o
	@$(VECHO) LD32 "(hugelink test)" $@
	$(CC32) $(LDFLAGS) $(LDFLAGS32) -o $@ $^ $(LDLIBS)

$(HUGELINK_TESTS:%=obj64/%): %: %.o obj64/testutils.o
	@$(VECHO) LD64 "(hugelink test)" $@
	$(CC64) $(LDFLAGS) $(LDFLAGS64) -o $@ $^ $(LDLIBS)

$(HUGELINK_RW_TESTS:%=obj32/%): %: %.o $(HUGETLBFS_LD) obj32/testutils.o
	@$(VECHO) LD32 "(hugelink_rw test)" $@
	@mkdir -p obj32
	@ln -sf ../$(HUGETLBFS_LD) obj32/ld
	$(CC32) -B./obj32 $(LDFLAGS) $(LDFLAGS32) -o $@ $(LDLIBS) -Wl,--hugetlbfs-align $(filter %.o,$^)

$(HUGELINK_RW_TESTS:%=obj64/%): %: %.o $(HUGETLBFS_LD) obj64/testutils.o
	@$(VECHO) LD64 "(hugelink_rw test)" $@
	@mkdir -p obj64
	@ln -sf ../$(HUGETLBFS_LD) obj64/ld
	$(CC64) -B./obj64 $(LDFLAGS) $(LDFLAGS64) -o $@ $(LDLIBS) -Wl,--hugetlbfs-align $(filter %.o,$^)

$(STRESS_TESTS:%=obj32/%): %: %.o obj32/testutils.o
	@$(VECHO) LD32 "(lib test)" $@
	$(CC32) $(LDFLAGS) $(LDFLAGS32) -o $@ $^ $(LDLIBS) -lhugetlbfs

$(STRESS_TESTS:%=obj64/%): %: %.o obj64/testutils.o
	@$(VECHO) LD64 "(lib test)" $@
	$(CC64) $(LDFLAGS) $(LDFLAGS64) -o $@ $^ $(LDLIBS) -lhugetlbfs

obj32/xB.%: $(SCRIPTS32).xB $(HUGETLBFS_LD) obj32/%.o obj32/testutils.o
	@$(VECHO) LD32 "(xB test)" $@
	@mkdir -p obj32
	@ln -sf ../$(HUGETLBFS_LD) obj32/ld
	HUGETLB_DEPRECATED_LINK=1 $(CC32) -B./obj32  $(LDFLAGS) $(LDFLAGS32) -o $@ $(LDLIBS) -Wl,--hugetlbfs-link=B $(filter %.o,$^)

obj64/xB.%: $(SCRIPTS64).xB $(HUGETLBFS_LD) obj64/%.o obj64/testutils.o
	@$(VECHO) LD64 "(xB test)" $@
	@mkdir -p obj64
	@ln -sf ../$(HUGETLBFS_LD) obj64/ld
	HUGETLB_DEPRECATED_LINK=1 $(CC64) -B./obj64 $(LDFLAGS) $(LDFLAGS64) -o $@ $(LDLIBS) -Wl,--hugetlbfs-link=B $(filter %.o,$^)

obj32/xBDT.%: $(SCRIPTS32).xBDT $(HUGETLBFS_LD) obj32/%.o obj32/testutils.o
	@$(VECHO) LD32 "(xBDT test)" $@
	@mkdir -p obj32
	@ln -sf ../$(HUGETLBFS_LD) obj32/ld
	HUGETLB_DEPRECATED_LINK=1 $(CC32) -B./obj32 $(LDFLAGS) $(LDFLAGS32) -o $@ $(LDLIBS) -Wl,--hugetlbfs-link=BDT $(filter %.o,$^)

obj64/xBDT.%: $(SCRIPTS64).xBDT $(HUGETLBFS_LD) obj64/%.o obj64/testutils.o
	@$(VECHO) LD64 "(xBDT test)" $@
	@mkdir -p obj64
	@ln -sf ../$(HUGETLBFS_LD) obj64/ld
	HUGETLB_DEPRECATED_LINK=1 $(CC64) -B./obj64 $(LDFLAGS) $(LDFLAGS64) -o $@ $(LDLIBS) -Wl,--hugetlbfs-link=BDT $(filter %.o,$^)

$(HELPERS:%=obj32/%): %: %.o
	@$(VECHO) LD32 "(helper)" $@
	$(CC32) $(LDFLAGS) $(LDFLAGS32) -o $@ $^ $(LDLIBS) -lhugetlbfs

$(HELPERS:%=obj64/%): %: %.o
	@$(VECHO) LD64 "(helper)" $@
	$(CC64) $(LDFLAGS) $(LDFLAGS64) -o $@ $^ $(LDLIBS) -lhugetlbfs

$(WRAPPERS32): obj32/%.sh: %.sh obj32/%
	@$(VECHO) COPY "(wrapped test)" $@
	@cp -f $< $@

$(WRAPPERS64): obj64/%.sh: %.sh obj64/%
	@$(VECHO) COPY "(wrapped test)" $@
	@cp -f $< $@

clean:
	@$(VECHO) CLEAN "(tests)"
	rm -f *~ *.o *.so *.a *.d core a.out
	rm -rf obj*
	rm -f shmoverride_linked.c # Autogenerated file
	rm -f $(TESTS)

%.d: %.c
	@$(CC) $(CPPFLAGS) -MM -MT "$(foreach DIR,$(OBJDIRS),$(DIR)/$*.o) $@" $< > $@

-include $(DEPFILES)

obj32/install:
	@$(VECHO) INSTALL32 $(INST_TESTSDIR32)
	$(INSTALL) -d $(DESTDIR)$(INST_TESTSDIR32)
	$(INSTALL) -d $(DESTDIR)$(INST_TESTSDIR32)/obj32
	$(INSTALL) -m 755 $(TESTS:%=obj32/%) $(DESTDIR)$(INST_TESTSDIR32)/obj32
	$(INSTALL) -m 755 $(WRAPPERS32) $(DESTDIR)$(INST_TESTSDIR32)/obj32
	$(INSTALL) -m 755 wrapper-utils.sh $(DESTDIR)$(INST_TESTSDIR32)/obj32
	$(INSTALL) -m 755 $(HELPERS:%=obj32/%) $(DESTDIR)$(INST_TESTSDIR32)/obj32
	$(INSTALL) -m 755 $(HELPER_LIBS:%=obj32/%) $(DESTDIR)$(INST_TESTSDIR32)/obj32
	$(INSTALL) -m 755 run_tests.sh $(DESTDIR)$(INST_TESTSDIR32)

obj64/install:
	@$(VECHO) INSTALL64 $(INST_TESTSDIR64)
	$(INSTALL) -d $(DESTDIR)$(INST_TESTSDIR64)
	$(INSTALL) -d $(DESTDIR)$(INST_TESTSDIR64)/obj64
	$(INSTALL) -m 755 $(TESTS:%=obj64/%) $(DESTDIR)$(INST_TESTSDIR64)/obj64
	$(INSTALL) -m 755 $(WRAPPERS64) $(DESTDIR)$(INST_TESTSDIR64)/obj64
	$(INSTALL) -m 755 wrapper-utils.sh $(DESTDIR)$(INST_TESTSDIR64)/obj64
	$(INSTALL) -m 755 $(HELPERS:%=obj64/%) $(DESTDIR)$(INST_TESTSDIR64)/obj64
	$(INSTALL) -m 755 $(HELPER_LIBS:%=obj64/%) $(DESTDIR)$(INST_TESTSDIR64)/obj64
	$(INSTALL) -m 755 $(TESTS_64:%=obj64/%) $(DESTDIR)$(INST_TESTSDIR64)/obj64
	$(INSTALL) -m 755 run_tests.sh $(DESTDIR)$(INST_TESTSDIR64)

install: $(OBJDIRS:%=%/install)

=== debian/changelog ===
libhugetlbfs (2.11-0ubuntu1) natty; urgency=low

  * libhugetlbfs 2.11 release.
  * Package linker scripts in the -dev package.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 22 Feb 2011 23:52:56 +0100

libhugetlbfs (2.10-0ubuntu1) natty; urgency=low

  * libhugetlbfs 2.10 release.
  * Rename libhugetlbfs package to libhugetlbfs0.
  * Change the soname to .0, but keep the .so files in the library
    package.
  * Link libraries with -ldl.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 23 Nov 2010 11:01:00 +0100

libhugetlbfs (2.7-1) unstable; urgency=low

  * Initial release (Closes: #533708)
  * Thanks to Mel Gorman, David Brown, The Fedora and The Gentoo
    Projects for their previous work on packaging libhugetlbfs,
    which greatly helped doing this package.

 -- Frank Lin PIAT <fpiat@klabs.be>  Thu, 18 Mar 2010 08:29:50 +0100

=== debian/control ===
Source: libhugetlbfs
Priority: extra
Maintainer: Frank Lin PIAT <fpiat@klabs.be>, Vincent Danjean <Vincent.Danjean@ens-lyon.org>
Build-Depends: debhelper (>= 7.0.50~), quilt
Standards-Version: 3.8.4
Section: libs
Homepage: http://libhugetlbfs.sourceforge.net/

Package: libhugetlbfs0
Section: libs
Architecture: i386 amd64 powerpc ppc64
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: hugepages
Description: A library which provides easy access to huge pages of memory
 libhugetlbfs is a library which provides easy access to huge pages of memory.
 It is a wrapper for the hugetlbfs file system. Applications can use huge pages
 to fulfill malloc() requests without being recompiled by using LD_PRELOAD.
 Alternatively, applications can be linked against libhugetlbfs without source
 modifications to load BSS or BSS, data, and text segments into large pages.
 .
 This package provides the applications for preloading libhugetlbfs

Package: libhugetlbfs-tests
Section: libs
Architecture: i386 amd64 powerpc ppc64
Depends: ${shlibs:Depends}, ${misc:Depends}, hugepages, ${python:Depends}
Recommends: libhugetlbfs0
Suggests: oprofile
Description: A library which provides easy access to huge pages of memory
 libhugetlbfs is a library which provides easy access to huge pages of memory.
 It is a wrapper for the hugetlbfs file system. Applications can use huge pages
 to fulfill malloc() requests without being recompiled by using LD_PRELOAD.
 Alternatively, applications can be linked against libhugetlbfs without source
 modifications to load BSS or BSS, data, and text segments into large pages.
 . 
 This package provides the test-suite for libhugetlbfs, which is mostly useful
 for regression testing of libhugetlbfs.

Package: hugepages
Section: admin
Architecture: i386 amd64 powerpc ppc64
Depends: ${shlibs:Depends}, ${misc:Depends}, libhugetlbfs0 (= ${binary:Version}), ${python:Depends}
Suggests: libhugetlbfs-tests
Description: A set of tools to configure huge pages of memory
 This package contains a number of utilities that will help administrate the
 use of huge pages on your system.  hugeedit modifies binaries to set default
 segment remapping behavior. hugectl sets environment variables for using huge
 pages and then execs the target program. hugeadm gives easy access to huge page
 pool size control. pagesize lists page sizes available on the machine.

Package: libhugetlbfs-dev
Section: libdevel
Architecture: i386 amd64 powerpc ppc64
Depends: libhugetlbfs0 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: A library which provides easy access to huge pages of memory
 libhugetlbfs is a library which provides easy access to huge pages of memory.
 It is a wrapper for the hugetlbfs file system. Applications can use huge pages
 to fulfill malloc() requests without being recompiled by using LD_PRELOAD.
 Alternatively, applications can be linked against libhugetlbfs without source
 modifications to load BSS or BSS, data, and text segments into large pages.
 .
 This package provides the headers and development libraries

=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

#DEB_BUILD_OPTIONS=parallel=
#MAKEFLAGS=-j1

# work around LP: #723515
export DEB_GCC_NO_O3=1

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

ifneq (,$(filter $(DEB_HOST_ARCH), amd64 ppc64))
  LIBARGS = LIB32=lib32 LIB64=lib V=1
else ifneq (,$(filter $(DEB_HOST_ARCH), i386 powerpc))
  LIBARGS = LIB32=lib LIB64=lib64 V=1
endif


%:
	dh  $@ --with quilt

override_dh_auto_clean:
	$(MAKE) clean

override_dh_auto_build:
	# Parallel builds are not reliable
	$(MAKE) BUILDTYPE=NATIVEONLY $(LIBARGS)

override_dh_auto_install:
	mkdir -p debian/tmp/usr/share/libhugetlbfs/tests
	$(MAKE) install PREFIX=/usr DESTDIR=$(CURDIR)/debian/tmp BUILDTYPE=NATIVEONLY $(LIBARGS)
	$(MAKE) install-helper PREFIX=/usr DESTDIR=$(CURDIR)/debian/tmp BUILDTYPE=NATIVEONLY $(LIBARGS)
	$(MAKE) install-tests PREFIX=/usr DESTDIR=$(CURDIR)/debian/tmp BUILDTYPE=NATIVEONLY $(LIBARGS) INST_TESTSDIR64=/usr/share/libhugetlbfs/tests INST_TESTSDIR32=/usr/share/libhugetlbfs/tests

	# Fix minor issues
	find debian/tmp/  -name dummy.ldscript -print0 | xargs -r0 chmod a-x
	# Actually, we don't want hat helper.
	# mv debian/tmp/usr/bin/huge_page_setup_helper.py debian/tmp/usr/bin/huge_page_setup_helper

	install -m 755 -d $(CURDIR)/debian/tmp/etc/security/limits.d
	install -m 644 $(CURDIR)/debian/limits.conf $(CURDIR)/debian/tmp/etc/security/limits.d/hugepages.conf

#	mv debian/tmp/usr/lib/libhugetlbfs.so debian/tmp/usr/lib/libhugetlbfs.so.0
#	ln -sf libhugetlbfs.so.0 debian/tmp/usr/lib/libhugetlbfs.so
#	mv debian/tmp/usr/lib/libhugetlbfs_privutils.so debian/tmp/usr/lib/libhugetlbfs_privutils.so.0
#	ln -sf libhugetlbfs_privutils.so.0 debian/tmp/usr/lib/libhugetlbfs_privutils.so

	dh_install --sourcedir=debian/tmp

override_dh_auto_test:
	-echo "SKIP tests, as they require privilege (FIXME)"

## libhugetlbfs 2.17

=== Makefile ===
--- 
+++ 
@@ -11,9 +11,10 @@
 INSTALL_HELPER = huge_page_setup_helper.py
 INSTALL_PERLMOD = DataCollect.pm OpCollect.pm PerfCollect.pm Report.pm
 INSTALL_HEADERS = hugetlbfs.h
-INSTALL_MAN1 = pagesize.1
-INSTALL_MAN3 = get_huge_pages.3 get_hugepage_region.3 \
-		gethugepagesizes.3 getpagesizes.3
+INSTALL_MAN1 = ld.hugetlbfs.1 pagesize.1
+INSTALL_MAN3 = get_huge_pages.3 get_hugepage_region.3 gethugepagesize.3 \
+		gethugepagesizes.3 getpagesizes.3 hugetlbfs_find_path.3 \
+		hugetlbfs_test_path.3 hugetlbfs_unlinked_fd.3
 INSTALL_MAN7 = libhugetlbfs.7
 INSTALL_MAN8 = hugectl.8 hugeedit.8 hugeadm.8 cpupcstat.8
 LDSCRIPT_TYPES = B BDT
@@ -29,58 +30,77 @@
 LDFLAGS += -Wl,-z,noexecstack -ldl
 CFLAGS ?= -O2 -g
 CFLAGS += -Wall -fPIC
-CPPFLAGS += -D__LIBHUGETLBFS__
+CPPFLAGS += -D__LIBHUGETLBFS__ -DPPC_NO_SEGMENTS
 
 ARCH = $(shell uname -m | sed -e s/i.86/i386/)
-
-ifeq ($(ARCH),ppc64)
-CC64 = gcc -m64
+CC = gcc
+
+CUSTOM_LDSCRIPTS = yes
+
+ifeq ($(ARCH),powerpc64)
+CC64 = $(CC) -m64
 ELF64 = elf64ppc
 TMPLIB64 = lib64
 TMPLIB32 = lib
 ifneq ($(BUILDTYPE),NATIVEONLY)
-CC32 = gcc -m32
+CC32 = $(CC) -m32
 ELF32 = elf32ppclinux
 endif
 else
-ifeq ($(ARCH),ppc)
-CC32 = gcc -m32
+ifeq ($(ARCH),powerpc)
+CC32 = $(CC) -m32
 ELF32 = elf32ppclinux
 TMPLIB32 = lib
 else
+ifeq ($(ARCH),armv7l)
+CC32 = $(CC)
+TMPLIB32 = lib
+ELF32 += armelf_linux_eabi
+CUSTOM_LDSCRIPTS = no
+else
+ifeq ($(ARCH),aarch64)
+CC64 = gcc
+ELF64 = aarch64elf
+TMPLIB64 = lib64
+CUSTOM_LDSCRIPTS = no
+else
 ifeq ($(ARCH),i386)
-CC32 = gcc
+CC32 = $(CC)
 ELF32 = elf_i386
 TMPLIB32 = lib
 else
 ifeq ($(ARCH),x86_64)
-CC64 = gcc -m64
+CC64 = $(CC) -m64
 ELF64 = elf_x86_64
 TMPLIB64 = lib64
 TMPLIB32 = lib
 ifneq ($(BUILDTYPE),NATIVEONLY)
-CC32 = gcc -m32
+CC32 = $(CC) -m32
 ELF32 = elf_i386
 endif
 else
 ifeq ($(ARCH),ia64)
-CC64 = gcc
+CC64 = $(CC)
 TMPLIB64 = lib64
 CFLAGS += -DNO_ELFLINK
 else
 ifeq ($(ARCH),sparc64)
-CC64 = gcc -m64
+CC64 = $(CC) -m64
 TMPLIB64 = lib64
 CFLAGS += -DNO_ELFLINK
 else
 ifeq ($(ARCH),s390x)
-CC64 = gcc -m64
-CC32 = gcc -m31
-TMPLIB64 = lib64
-TMPLIB32 = lib
-CFLAGS += -DNO_ELFLINK
+CC64 = $(CC) -m64
+CC32 = $(CC) -m31
+ELF32 = elf_s390
+ELF64 = elf64_s390
+TMPLIB64 = lib64
+TMPLIB32 = lib
+CUSTOM_LDSCRIPTS = no
 else
 $(error "Unrecognized architecture ($(ARCH))")
+endif
+endif
 endif
 endif
 endif
@@ -125,6 +145,10 @@
 ifeq ($(LIB64),)
 LIB64 = $(TMPLIB64)
 endif
+endif
+
+ifeq ($(CUSTOM_LDSCRIPTS),yes)
+TEST_LDSCRIPTS = -l
 endif
 
 # If TMPLIB64 is set, then sure we are not resolving LIB32 and LIB64 to the
@@ -148,7 +172,11 @@
 BINDIR = $(PREFIX)/share/libhugetlbfs
 EXEDIR = $(PREFIX)/bin
 DOCDIR = $(PREFIX)/share/doc/libhugetlbfs
+ifdef CC32
 PMDIR = $(PREFIX)/lib/perl5/TLBC
+else
+PMDIR = $(PREFIX)/lib64/perl5/TLBC
+endif
 MANDIR1 = $(PREFIX)/share/man/man1
 MANDIR3 = $(PREFIX)/share/man/man3
 MANDIR7 = $(PREFIX)/share/man/man7
@@ -186,6 +214,7 @@
 export ELF64
 export LIBDIR32
 export LIBDIR64
+export CUSTOM_LDSCRIPTS
 
 all:	libs tests tools
 
@@ -196,22 +225,22 @@
 tests:	libs # Force make to build the library first
 tests:	tests/all
 
-tests/%:
+tests/%: libs
 	$(MAKE) -C tests $*
 
 tools:  $(foreach file,$(INSTALL_BIN),$(BIN_OBJ_DIR)/$(file))
 
 check:	all
-	cd tests; ./run_tests.py
+	cd tests; ./run_tests.py $(TEST_LDSCRIPTS)
 
 checkv:	all
-	cd tests; ./run_tests.py -vV
+	cd tests; ./run_tests.py -vV $(TEST_LDSCRIPTS)
 
 func:	all
-	cd tests; ./run_tests.py -t func
+	cd tests; ./run_tests.py -t func $(TEST_LDSCRIPTS)
 
 funcv:	all
-	cd tests; ./run_tests.py -t func -vV
+	cd tests; ./run_tests.py -t func -vV $(TEST_LDSCRIPTS)
 
 stress:	all
 	cd tests; ./run_tests.py -t stress
@@ -364,7 +393,7 @@
 
 objscript.%: %
 	@$(VECHO) OBJSCRIPT $*
-	sed "s!### SET DEFAULT LDSCRIPT PATH HERE ###!HUGETLB_LDSCRIPT_PATH=$(LDSCRIPTDIR)!" < $< > $@
+	sed "s!### SET DEFAULT LDSCRIPT PATH HERE ###!HUGETLB_LDSCRIPT_PATH=$(LDSCRIPTDIR)!;s!### SET CUSTOM_LDSCRIPTS HERE ###!CUSTOM_LDSCRIPTS=\"$(CUSTOM_LDSCRIPTS)\"!" < $< > $@
 
 install-libs: libs $(OBJDIRS:%=%/install) $(INSTALL_OBJSCRIPT:%=objscript.%)
 	$(INSTALL) -d $(DESTDIR)$(HEADERDIR)
@@ -392,8 +421,12 @@
 	done
 	rm -f $(DESTDIR)$(MANDIR3)/free_huge_pages.3.gz
 	rm -f $(DESTDIR)$(MANDIR3)/free_hugepage_region.3.gz
+	rm -f $(DESTDIR)$(MANDIR3)/hugetlbfs_unlinked_fd_for_size.3.gz
+	rm -f $(DESTDIR)$(MANDIR3)/hugetlbfs_find_path_for_size.3.gz
 	ln -s get_huge_pages.3.gz $(DESTDIR)$(MANDIR3)/free_huge_pages.3.gz
 	ln -s get_hugepage_region.3.gz $(DESTDIR)$(MANDIR3)/free_hugepage_region.3.gz
+	ln -s hugetlbfs_unlinked_fd.3.gz $(DESTDIR)$(MANDIR3)/hugetlbfs_unlinked_fd_for_size.3.gz
+	ln -s hugetlbfs_find_path.3.gz $(DESTDIR)$(MANDIR3)/hugetlbfs_find_path_for_size.3.gz
 	for x in $(INSTALL_MAN7); do \
 		$(INSTALL) -m 444 man/$$x $(DESTDIR)$(MANDIR7); \
 		gzip -f $(DESTDIR)$(MANDIR7)/$$x; \
@@ -429,9 +462,3 @@
 	for x in $(INSTALL_HELPER); do \
 		$(INSTALL) -m 755 $$x $(DESTDIR)$(EXEDIR); done
 
-install-docs:
-	$(INSTALL) -d $(DESTDIR)$(DOCDIR)
-	for x in $(EXTRA_DIST); do $(INSTALL) -m 755 $$x $(DESTDIR)$(DOCDIR)/$$x; done
-
-install-tests: tests install	# Force make to build tests and install the library first
-	${MAKE} -C tests install DESTDIR=$(DESTDIR) OBJDIRS="$(OBJDIRS)" LIB32=$(LIB32) LIB64=$(LIB64)

=== debian/changelog ===
libhugetlbfs (2.17-0ubuntu2) trusty; urgency=medium

  * Fix build on powerpc.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 11 Jan 2014 06:28:18 +0100

libhugetlbfs (2.17-0ubuntu1) trusty; urgency=medium

  * New upstream version.
  * Build for ppc64el.
  * Fix installation of 64bit tests.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 11 Jan 2014 03:28:11 +0100

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,14 @@
 Source: libhugetlbfs
 Priority: extra
 Maintainer: Frank Lin PIAT <fpiat@klabs.be>, Vincent Danjean <Vincent.Danjean@ens-lyon.org>
-Build-Depends: debhelper (>= 7.0.50~), quilt
-Standards-Version: 3.8.4
+Build-Depends: debhelper (>= 7.0.50~)
+Standards-Version: 3.9.5
 Section: libs
 Homepage: http://libhugetlbfs.sourceforge.net/
 
 Package: libhugetlbfs0
 Section: libs
-Architecture: i386 amd64 powerpc ppc64
+Architecture: i386 amd64 powerpc ppc64 ppc64el armhf arm64
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Recommends: hugepages
 Description: A library which provides easy access to huge pages of memory
@@ -22,7 +22,7 @@
 
 Package: libhugetlbfs-tests
 Section: libs
-Architecture: i386 amd64 powerpc ppc64
+Architecture: i386 amd64 powerpc ppc64 ppc64el armhf arm64
 Depends: ${shlibs:Depends}, ${misc:Depends}, hugepages, ${python:Depends}
 Recommends: libhugetlbfs0
 Suggests: oprofile
@@ -38,7 +38,7 @@
 
 Package: hugepages
 Section: admin
-Architecture: i386 amd64 powerpc ppc64
+Architecture: i386 amd64 powerpc ppc64 ppc64el armhf arm64
 Depends: ${shlibs:Depends}, ${misc:Depends}, libhugetlbfs0 (= ${binary:Version}), ${python:Depends}
 Suggests: libhugetlbfs-tests
 Description: A set of tools to configure huge pages of memory
@@ -50,7 +50,7 @@
 
 Package: libhugetlbfs-dev
 Section: libdevel
-Architecture: i386 amd64 powerpc ppc64
+Architecture: i386 amd64 powerpc ppc64 ppc64el armhf arm64
 Depends: libhugetlbfs0 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
 Description: A library which provides easy access to huge pages of memory
  libhugetlbfs is a library which provides easy access to huge pages of memory.

=== debian/rules ===
--- 
+++ 
@@ -1,16 +1,13 @@
 #!/usr/bin/make -f
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
-
-#DEB_BUILD_OPTIONS=parallel=
-#MAKEFLAGS=-j1
 
 # work around LP: #723515
 export DEB_GCC_NO_O3=1
 
 DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
 
-ifneq (,$(filter $(DEB_HOST_ARCH), amd64 ppc64))
+ifneq (,$(filter $(DEB_HOST_ARCH), amd64 ppc64 ppc64el))
   LIBARGS = LIB32=lib32 LIB64=lib V=1
 else ifneq (,$(filter $(DEB_HOST_ARCH), i386 powerpc))
   LIBARGS = LIB32=lib LIB64=lib64 V=1
@@ -18,14 +15,14 @@
 
 
 %:
-	dh  $@ --with quilt
+	dh $@
 
 override_dh_auto_clean:
-	$(MAKE) clean
+	$(MAKE) clean V=1
 
 override_dh_auto_build:
 	# Parallel builds are not reliable
-	$(MAKE) BUILDTYPE=NATIVEONLY $(LIBARGS)
+	$(MAKE) BUILDTYPE=NATIVEONLY $(LIBARGS) V=1
 
 override_dh_auto_install:
 	mkdir -p debian/tmp/usr/share/libhugetlbfs/tests

## libhugetlbfs 2.19

=== tests/Makefile ===
--- 
+++ 
@@ -10,14 +10,20 @@
 	counters quota heap-overflow get_huge_pages get_hugepage_region \
 	shmoverride_linked gethugepagesizes \
 	madvise_reserve fadvise_reserve readahead_reserve \
-	shm-perms
-LIB_TESTS_64 = straddle_4GB huge_at_4GB_normal_below \
+	shm-perms \
+	mremap-expand-slice-collision \
+	mremap-fixed-normal-near-huge mremap-fixed-huge-near-normal \
+	corrupt-by-cow-opt noresv-preserve-resv-page noresv-regarded-as-resv
+LIB_TESTS_64 =
+LIB_TESTS_64_STATIC = straddle_4GB huge_at_4GB_normal_below \
 	huge_below_4GB_normal_above
+LIB_TESTS_64_ALL = $(LIB_TESTS_64) $(LIB_TESTS_64_STATIC)
 NOLIB_TESTS = malloc malloc_manysmall dummy heapshrink shmoverride_unlinked
 LDSCRIPT_TESTS = zero_filesize_segment
 HUGELINK_TESTS = linkhuge linkhuge_nofd linkshare
 HUGELINK_RW_TESTS = linkhuge_rw
 STRESS_TESTS = mmap-gettest mmap-cow shm-gettest shm-getraw shm-fork
+# NOTE: all named tests in WRAPPERS must also be named in TESTS
 WRAPPERS = quota counters madvise_reserve fadvise_reserve \
 	readahead_reserve mremap-expand-slice-collision \
 	mremap-fixed-normal-near-huge mremap-fixed-huge-near-normal
@@ -27,24 +33,37 @@
 
 CFLAGS = -O2 -Wall -g
 CPPFLAGS = -I..
-LDLIBS = -Wl,--no-as-needed -ldl -lpthread -lhugetlbfs_privutils
+STATIC_LIBHUGE = -Wl,--whole-archive -lhugetlbfs -Wl,--no-whole-archive
+STATIC_LDLIBS = -Wl,--no-as-needed -lpthread
+LDLIBS = $(STATIC_LDLIBS) -ldl -lhugetlbfs_privutils
 LDFLAGS32 = -L../obj32
 LDFLAGS64 = -L../obj64
 INSTALL = install
 
 TESTS = $(LIB_TESTS) $(NOLIB_TESTS) $(STRESS_TESTS) dummy.ldscript
 ifdef ELF32
+ifeq ($(CUSTOM_LDSCRIPTS),yes)
 TESTS += $(LDSCRIPT_TESTS) $(HUGELINK_TESTS) $(HUGELINK_TESTS:%=xB.%) \
 	$(HUGELINK_TESTS:%=xBDT.%) $(HUGELINK_RW_TESTS)
 else
+TESTS += $(LDSCRIPT_TESTS) $(HUGELINK_TESTS) $(HUGELINK_RW_TESTS)
+endif
+
+else
 ifdef ELF64
+ifeq ($(CUSTOM_LDSCRIPTS),yes)
 TESTS += $(LDSCRIPT_TESTS) $(HUGELINK_TESTS) $(HUGELINK_TESTS:%=xB.%) \
 	$(HUGELINK_TESTS:%=xBDT.%)
+else
+TESTS += $(LDSCRIPT_TESTS) $(HUGELINK_TESTS) $(HUGELINK_RW_TESTS)
+endif
+
 endif
 endif
 
 ifneq ($(ARCH),ia64)
 TESTS_64 = $(LIB_TESTS_64)
+TESTS_64_STATIC = $(LIB_TESTS_64_STATIC)
 endif
 
 SCRIPTS=../ldscripts
@@ -69,6 +88,20 @@
 ALLHELPERLIBS = $(foreach DIR,$(OBJDIRS),$(HELPER_LIBS:%=$(DIR)/%))
 ifdef CC64
 ALLTESTS += $(TESTS_64:%=obj64/%)
+ALLTESTS += $(TESTS_64_STATIC:%=obj64/%_static)
+endif
+
+# For now, build only one test as a static binary.
+# Can be changed once libhugetlbfs has better support for static linking.
+# Also, some tests should be changed to use syscall() instead of
+#  dlsym() / rtld_next().
+ifdef CC32
+#ALLTESTS += $(LIB_TESTS:%=obj32/%_static) $(STRESS_TESTS:%=obj32/%_static)
+ALLTESTS += obj32/shmoverride_linked_static
+endif
+ifdef CC64
+#ALLTESTS += $(LIB_TESTS:%=obj64/%_static) $(STRESS_TESTS:%=obj64/%_static)
+ALLTESTS += obj64/shmoverride_linked_static
 endif
 
 objs_needing_wrappers = \
@@ -116,9 +149,17 @@
 	@$(VECHO) LD32 "(lib test)" $@
 	$(CC32) $(LDFLAGS) $(LDFLAGS32) -o $@ $^ $(LDLIBS) -lhugetlbfs
 
-$(LIB_TESTS:%=obj64/%) $(LIB_TESTS_64:%=obj64/%): %: %.o obj64/testutils.o obj64/libtestutils.o
+$(LIB_TESTS:%=obj64/%) $(LIB_TESTS_64_ALL:%=obj64/%): %: %.o obj64/testutils.o obj64/libtestutils.o
 	@$(VECHO) LD64 "(lib test)" $@
 	$(CC64) $(LDFLAGS) $(LDFLAGS64) -o $@ $^ $(LDLIBS) -lhugetlbfs
+
+$(LIB_TESTS:%=obj32/%_static): %_static: %.o obj32/testutils.o obj32/libtestutils.o
+	@$(VECHO) LD32 "(lib test)" $@
+	$(CC32) -static $(LDFLAGS) $(LDFLAGS32) -o $@ $^ $(STATIC_LDLIBS) $(STATIC_LIBHUGE)
+
+$(LIB_TESTS:%=obj64/%_static) $(LIB_TESTS_64_ALL:%=obj64/%_static): %_static: %.o obj64/testutils.o obj64/libtestutils.o
+	@$(VECHO) LD64 "(lib test)" $@
+	$(CC64) -static $(LDFLAGS) $(LDFLAGS64) -o $@ $^ $(STATIC_LDLIBS) $(STATIC_LIBHUGE)
 
 $(NOLIB_TESTS:%=obj32/%): %: %.o obj32/testutils.o
 	@$(VECHO) LD32 "(nolib test)" $@
@@ -171,6 +212,14 @@
 $(STRESS_TESTS:%=obj64/%): %: %.o obj64/testutils.o
 	@$(VECHO) LD64 "(lib test)" $@
 	$(CC64) $(LDFLAGS) $(LDFLAGS64) -o $@ $^ $(LDLIBS) -lhugetlbfs
+
+$(STRESS_TESTS:%=obj32/%_static): %_static: %.o obj32/testutils.o
+	@$(VECHO) LD32 "(lib test)" $@
+	$(CC32) -static $(LDFLAGS) $(LDFLAGS32) -o $@ $^ $(STATIC_LDLIBS) $(STATIC_LIBHUGE)
+
+$(STRESS_TESTS:%=obj64/%_static): %_static: %.o obj64/testutils.o
+	@$(VECHO) LD64 "(lib test)" $@
+	$(CC64) -static $(LDFLAGS) $(LDFLAGS64) -o $@ $^ $(STATIC_LDLIBS) $(STATIC_LIBHUGE)
 
 obj32/xB.%: $(SCRIPTS32).xB $(HUGETLBFS_LD) obj32/%.o obj32/testutils.o
 	@$(VECHO) LD32 "(xB test)" $@
@@ -233,7 +282,7 @@
 	$(INSTALL) -m 755 wrapper-utils.sh $(DESTDIR)$(INST_TESTSDIR32)/obj32
 	$(INSTALL) -m 755 $(HELPERS:%=obj32/%) $(DESTDIR)$(INST_TESTSDIR32)/obj32
 	$(INSTALL) -m 755 $(HELPER_LIBS:%=obj32/%) $(DESTDIR)$(INST_TESTSDIR32)/obj32
-	$(INSTALL) -m 755 run_tests.sh $(DESTDIR)$(INST_TESTSDIR32)
+	$(INSTALL) -m 755 run_tests.py $(DESTDIR)$(INST_TESTSDIR32)
 
 obj64/install:
 	@$(VECHO) INSTALL64 $(INST_TESTSDIR64)
@@ -245,6 +294,6 @@
 	$(INSTALL) -m 755 $(HELPERS:%=obj64/%) $(DESTDIR)$(INST_TESTSDIR64)/obj64
 	$(INSTALL) -m 755 $(HELPER_LIBS:%=obj64/%) $(DESTDIR)$(INST_TESTSDIR64)/obj64
 	$(INSTALL) -m 755 $(TESTS_64:%=obj64/%) $(DESTDIR)$(INST_TESTSDIR64)/obj64
-	$(INSTALL) -m 755 run_tests.sh $(DESTDIR)$(INST_TESTSDIR64)
+	$(INSTALL) -m 755 run_tests.py $(DESTDIR)$(INST_TESTSDIR64)
 
 install: $(OBJDIRS:%=%/install)

=== debian/changelog ===
libhugetlbfs (2.19-0ubuntu1) xenial; urgency=medium

  * New upstream version.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 04 Nov 2015 18:17:35 +0100

libhugetlbfs (2.17-0ubuntu3) wily; urgency=medium

  * debian/patches/gcc5-fix.diff: Fix FTBFS with GCC 5 with cherrypick from
    upstream Git.

 -- Logan Rosen <logan@ubuntu.com>  Mon, 19 Oct 2015 15:47:19 -0400

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,9 @@
 Source: libhugetlbfs
 Priority: extra
-Maintainer: Frank Lin PIAT <fpiat@klabs.be>, Vincent Danjean <Vincent.Danjean@ens-lyon.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Frank Lin PIAT <fpiat@klabs.be>, Vincent Danjean <Vincent.Danjean@ens-lyon.org>
 Build-Depends: debhelper (>= 7.0.50~)
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Section: libs
 Homepage: http://libhugetlbfs.sourceforge.net/

=== debian/rules ===
--- 
+++ 
@@ -19,9 +19,11 @@
 
 override_dh_auto_clean:
 	$(MAKE) clean V=1
+	rm -f version
 
 override_dh_auto_build:
-	# Parallel builds are not reliable
+	echo $$(dpkg-parsechangelog | awk '/^Version:/ {print $2}') > version
+	: # Parallel builds are not reliable
 	$(MAKE) BUILDTYPE=NATIVEONLY $(LIBARGS) V=1
 
 override_dh_auto_install:

=== debian/watch ===
version=3
http://sf.net/libhugetlbfs/libhugetlbfs-(.+)\.tar\.gz
